#include "stm8l101.h"
#include "stm8_type.h"
#include "RAM_code.h"


#pragma section (ram_code)

void Left_Button_RAM(void)
{ u8 c;

  LCD_INDEX[2]--;
	  if (LCD_INDEX[2] > 9)
  	{
	  	LCD_INDEX[2] = 9;
  	  LCD_INDEX[1]--;
  	  if (LCD_INDEX[1] > 9)
	  	{
		  	LCD_INDEX[1] = 9;
			  LCD_INDEX[0]--;
  			if (LCD_INDEX[0] > 9)
	  		{
		  		LCD_INDEX[0] = 9;
			  }
  		}
	  }

  { u8 S1,S2,S3; // Temporary registers for LCD decoding
	  S1 = LCD_VALUE[LCD_INDEX[2]];
		S2 = LCD_VALUE[LCD_INDEX[1]];
		S3 = LCD_VALUE[LCD_INDEX[0]]; 
		
		//special decoding is needed thanks to layout of PCB... 
		// segments has been swapped - see schematics
    PA_ODR = ((S3 & 0xF0) >> 2);
		PB_ODR = (S2 & 0x0F) + ((S1 & 0x0F) << 4);
    PC_ODR = ((S2 & 0xF0) >> 1); 
    PD_ODR = (S3 & 0x0F) + ((S1 & 0xE0) >> 1);
	}

/*  //this could be used for "transparent" segments mapping
      PB_ODR = LCD_VALUE[LCD_INDEX[2]];
      PC_ODR = LCD_VALUE[LCD_INDEX[1]];
      PD_ODR = LCD_VALUE[LCD_INDEX[0]] | LCD_P;
*/

  while (1)
	{ c++;
    if (c == 0x00)
  		{ PA_CR1 |= 0x40; //enable pull-up
        PB_ODR = ~PB_ODR;
        PC_ODR ^= 0x78;
	      PA_ODR ^= 0x3C;
    	  PD_ODR = ~PD_ODR;
				if (PA_IDR & 0x40)
				  break;
				PA_CR1 &= ~0x40; //disable pull-up
		  }
    #asm
		  nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			nop
    #endasm		//in order to decrease consumption by limiting fetch operation
  }; //wait for release of button
  for (c=0;c<0xFF;c++)
	{ if (!(PA_IDR & 0x40)) c = 0;
	};
}

void Right_Button_RAM(void)
{ u8 temp = 4;

  AWU_CSR = 0x00; //AutoWakeup disable
  TIM2_CR1 = 0x11; //counter enable
  do
  { PC_CR1 |= 0x04; //enable pull-up

    PB_ODR = ~PB_ODR;
    PC_ODR ^= 0x78;
    PA_ODR ^= 0x3C;
    PD_ODR = ~PD_ODR;
    if (PC_IDR & 0x04)
      temp--;

    PC_CR1 &= ~0x04; //disable pull-up

  	CLK_CKDIVR = 0x03; //HSI as clock source, max divider
    	
  	_asm("wfe");
	  TIM2_SR1 &= 0xFE;
    CLK_CKDIVR = 0x00; //HSI as clock source, max divider
 	} while(temp);

  PC_CR1 |= 0x04; //enable pull-up
	AWU_CSR = 0x10; //AutoWakeup enable	
	TIM2_CR1 = 0x10;
  PC_CR2 = 0x04;  //enable interrupt for button PC2
  CFG_GCR = 0x03; //enable AL bit, disable SWIM		
}			


#pragma section (text)